Index: trunk/drmaa_utils/drmaa_utils/drmaa_util.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/drmaa_util.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/drmaa_util.c	(revision 1)
@@ -0,0 +1,431 @@
+/* $Id: drmaa_util.c 290 2010-09-14 15:58:09Z mmatloka $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <string.h>
+#include <stdlib.h>
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/drmaa_attrib.h>
+#include <drmaa_utils/drmaa_util.h>
+#include <drmaa_utils/logging.h>
+#include <drmaa_utils/template.h>
+#include <drmaa_utils/util.h>
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: drmaa_util.c 290 2010-09-14 15:58:09Z mmatloka $";
+#endif
+
+
+static char *
+fsd_expand_drmaa_ph_expand( fsd_expand_drmaa_ph_t *self, char *s, unsigned set )
+{
+	unsigned mask;
+
+	for(
+			mask = 1;
+			mask <= FSD_DRMAA_PH_INCR;
+			mask <<= 1
+			)
+	 {
+		const char *ph;
+		const char *value;
+
+		switch( mask )
+		 {
+			case FSD_DRMAA_PH_HD:
+				ph = DRMAA_PLACEHOLDER_HD;
+				value = self->home_directory;
+				break;
+			case FSD_DRMAA_PH_WD:
+				ph = DRMAA_PLACEHOLDER_WD;
+				value = self->working_directory;
+				break;
+			case FSD_DRMAA_PH_INCR:
+				ph = DRMAA_PLACEHOLDER_INCR;
+				value = self->bulk_incr;
+				break;
+			default:
+				fsd_assert( false );
+		 }
+		if( value == NULL )
+			value = "";
+
+		if( mask & set )
+			s = fsd_replace( s, ph, value );
+		else if( strstr( s, ph ) != NULL )
+		 {
+			fsd_log_warning((
+						"'%s' can not be expanded in '%s'; removing from string",
+						ph, s ));
+			s = fsd_replace( s, ph, "" );
+		 }
+	 }
+
+	return s;
+}
+
+static void
+fsd_expand_drmaa_ph_set( fsd_expand_drmaa_ph_t *self,
+		int placeholder, char *value )
+{
+	char **var;
+	switch( placeholder )
+	 {
+		case FSD_DRMAA_PH_HD:  var = &self->home_directory;  break;
+		case FSD_DRMAA_PH_WD:  var = &self->working_directory;  break;
+		case FSD_DRMAA_PH_INCR:  var = &self->bulk_incr;  break;
+		default:
+			fsd_free( value );
+			fsd_exc_raise_code( FSD_ERRNO_INVALID_ARGUMENT );
+	 }
+	fsd_free( *var );
+	*var = value;
+}
+
+static void
+fsd_expand_drmaa_ph_destroy( fsd_expand_drmaa_ph_t *self )
+{
+	if( self != NULL )
+	 {
+		fsd_free( self->home_directory );
+		fsd_free( self->working_directory );
+		fsd_free( self->bulk_incr );
+		fsd_free( self );
+	 }
+}
+
+fsd_expand_drmaa_ph_t *
+fsd_expand_drmaa_ph_new(
+		char *home_directory,
+		char *working_directory,
+		char *bulk_incr
+		)
+{
+	fsd_expand_drmaa_ph_t *volatile p = NULL;
+
+	TRY
+	 {
+		fsd_expand_drmaa_ph_t *self;
+		fsd_malloc( p, fsd_expand_drmaa_ph_t );
+		self = p;
+		self->expand = fsd_expand_drmaa_ph_expand;
+		self->set = fsd_expand_drmaa_ph_set;
+		self->destroy = fsd_expand_drmaa_ph_destroy;
+
+		self->home_directory = home_directory;
+		self->working_directory = working_directory;
+		self->bulk_incr = bulk_incr;
+
+		if( self->home_directory == NULL )
+		 {
+			const char *home = getenv("HOME");
+			if( home == NULL )
+				home = "";
+			self->home_directory = fsd_strdup( home );
+		 }
+
+		if( self->working_directory == NULL )
+			self->working_directory = fsd_strdup(
+					self->home_directory );
+		else
+			self->working_directory = self->expand( self,
+					self->working_directory, FSD_DRMAA_PH_HD );
+
+		if( self->bulk_incr == NULL )
+			self->bulk_incr = fsd_strdup( "" );
+	 }
+	EXCEPT_DEFAULT
+	 {
+		if( p )
+			p->destroy( p );
+		fsd_exc_reraise();
+	 }
+	END_TRY
+	return p;
+}
+
+
+const char *
+drmaa_control_to_str( int action )
+{
+	switch( action )
+	 {
+		case DRMAA_CONTROL_SUSPEND:
+			return "suspend";
+		case DRMAA_CONTROL_RESUME:
+			return "resume";
+		case DRMAA_CONTROL_HOLD:
+			return "hold";
+		case DRMAA_CONTROL_RELEASE:
+			return "release";
+		case DRMAA_CONTROL_TERMINATE:
+			return "terminate";
+		default:
+			return "?";
+	 }
+}
+
+
+const char *
+drmaa_job_ps_to_str( int ps )
+{
+	switch( ps )
+	 {
+		case DRMAA_PS_UNDETERMINED:
+			return "undetermined";
+		case DRMAA_PS_QUEUED_ACTIVE:
+			return "queued_active";
+		case DRMAA_PS_SYSTEM_ON_HOLD:
+			return "system_on_hold";
+		case DRMAA_PS_USER_ON_HOLD:
+			return "user_on_hold";
+		case DRMAA_PS_USER_SYSTEM_ON_HOLD:
+			return "user_system_on_hold";
+		case DRMAA_PS_RUNNING:
+			return "running";
+		case DRMAA_PS_SYSTEM_SUSPENDED:
+			return "system_suspended";
+		case DRMAA_PS_USER_SUSPENDED:
+			return "user_suspended";
+		case DRMAA_PS_USER_SYSTEM_SUSPENDED:
+			return "user_system_suspended";
+		case DRMAA_PS_DONE:
+			return "done";
+		case DRMAA_PS_FAILED:
+			return "failed";
+		default:
+			return "?";
+	 }
+}
+
+
+int
+fsd_drmaa_code( int fsd_errno )
+{
+	switch( fsd_errno )
+	 {
+		case FSD_ERRNO_SUCCESS:
+			return DRMAA_ERRNO_SUCCESS;
+		case FSD_ERRNO_INTERNAL_ERROR:
+			return DRMAA_ERRNO_INTERNAL_ERROR;
+		case FSD_ERRNO_NO_MEMORY:
+			return DRMAA_ERRNO_NO_MEMORY;
+		case FSD_ERRNO_INVALID_ARGUMENT:
+			return DRMAA_ERRNO_INVALID_ARGUMENT;
+		case FSD_ERRNO_INVALID_VALUE:
+			return DRMAA_ERRNO_INVALID_ATTRIBUTE_VALUE;
+		case FSD_ERRNO_INVALID_VALUE_FORMAT:
+			return DRMAA_ERRNO_INVALID_ATTRIBUTE_FORMAT;
+		case FSD_ERRNO_STOP_ITERATION:
+			return DRMAA_ERRNO_NO_MORE_ELEMENTS;
+		case FSD_ERRNO_NOT_IMPLEMENTED:
+			return DRMAA_ERRNO_INTERNAL_ERROR;
+		case FSD_ERRNO_NOT_INITIALIZED:
+			return DRMAA_ERRNO_NO_ACTIVE_SESSION;
+		case FSD_ERRNO_TIMEOUT:
+			return DRMAA_ERRNO_EXIT_TIMEOUT;
+		case FSD_ERRNO_AUTH_FAILURE:
+			return DRMAA_ERRNO_AUTH_FAILURE;
+		case FSD_ERRNO_AUTHZ_FAILURE:
+			return DRMAA_ERRNO_AUTH_FAILURE;
+		case FSD_ERRNO_TRY_LATER:
+			return DRMAA_ERRNO_TRY_LATER;
+		case FSD_ERRNO_DRM_COMMUNICATION_FAILURE:
+			return DRMAA_ERRNO_DRM_COMMUNICATION_FAILURE;
+		case FSD_ERRNO_DRMS_INIT_FAILED:
+			return DRMAA_ERRNO_DRMS_INIT_FAILED;
+		case FSD_ERRNO_DRMS_EXIT_ERROR:
+			return DRMAA_ERRNO_DRMS_EXIT_ERROR;
+		case FSD_ERRNO_DENIED_BY_DRM:
+			return DRMAA_ERRNO_DENIED_BY_DRM;
+
+		case FSD_DRMAA_ERRNO_NO_ACTIVE_SESSION:
+			return DRMAA_ERRNO_NO_ACTIVE_SESSION;
+		case FSD_DRMAA_ERRNO_INVALID_CONTACT_STRING:
+			return DRMAA_ERRNO_INVALID_CONTACT_STRING;
+		case FSD_DRMAA_ERRNO_DEFAULT_CONTACT_STRING_ERROR:
+			return DRMAA_ERRNO_DEFAULT_CONTACT_STRING_ERROR;
+		case FSD_DRMAA_ERRNO_NO_DEFAULT_CONTACT_STRING_SELECTED:
+			return DRMAA_ERRNO_NO_DEFAULT_CONTACT_STRING_SELECTED;
+		case FSD_DRMAA_ERRNO_ALREADY_ACTIVE_SESSION:
+			return DRMAA_ERRNO_ALREADY_ACTIVE_SESSION;
+		case FSD_DRMAA_ERRNO_INVALID_ATTRIBUTE_FORMAT:
+			return DRMAA_ERRNO_INVALID_ATTRIBUTE_FORMAT;
+		case FSD_DRMAA_ERRNO_INVALID_ATTRIBUTE_VALUE:
+			return DRMAA_ERRNO_INVALID_ATTRIBUTE_VALUE;
+		case FSD_DRMAA_ERRNO_CONFLICTING_ATTRIBUTE_VALUES:
+			return DRMAA_ERRNO_CONFLICTING_ATTRIBUTE_VALUES;
+		case FSD_DRMAA_ERRNO_INVALID_JOB:
+			return DRMAA_ERRNO_INVALID_JOB;
+		case FSD_DRMAA_ERRNO_RESUME_INCONSISTENT_STATE:
+			return DRMAA_ERRNO_RESUME_INCONSISTENT_STATE;
+		case FSD_DRMAA_ERRNO_SUSPEND_INCONSISTENT_STATE:
+			return DRMAA_ERRNO_SUSPEND_INCONSISTENT_STATE;
+		case FSD_DRMAA_ERRNO_HOLD_INCONSISTENT_STATE:
+			return DRMAA_ERRNO_HOLD_INCONSISTENT_STATE;
+		case FSD_DRMAA_ERRNO_RELEASE_INCONSISTENT_STATE:
+			return DRMAA_ERRNO_RELEASE_INCONSISTENT_STATE;
+		case FSD_DRMAA_ERRNO_EXIT_TIMEOUT:
+			return DRMAA_ERRNO_EXIT_TIMEOUT;
+		case FSD_DRMAA_ERRNO_NO_RUSAGE:
+			return DRMAA_ERRNO_NO_RUSAGE;
+
+		default:
+			return DRMAA_ERRNO_INTERNAL_ERROR;
+	 }
+}
+
+
+int
+fsd_errno_from_drmaa_code( int drmaa_errno )
+{
+	switch( drmaa_errno )
+	 {
+		case DRMAA_ERRNO_SUCCESS:
+			return FSD_ERRNO_SUCCESS;
+		case DRMAA_ERRNO_INTERNAL_ERROR:
+			return FSD_ERRNO_INTERNAL_ERROR;
+		case DRMAA_ERRNO_DRM_COMMUNICATION_FAILURE:
+			return FSD_ERRNO_DRM_COMMUNICATION_FAILURE;
+		case DRMAA_ERRNO_AUTH_FAILURE:
+			return FSD_ERRNO_AUTHZ_FAILURE;
+		case DRMAA_ERRNO_INVALID_ARGUMENT:
+			return FSD_ERRNO_INVALID_ARGUMENT;
+		case DRMAA_ERRNO_NO_ACTIVE_SESSION:
+			return FSD_ERRNO_NOT_INITIALIZED;
+		case DRMAA_ERRNO_NO_MEMORY:
+			return FSD_ERRNO_NO_MEMORY;
+		case DRMAA_ERRNO_INVALID_CONTACT_STRING:
+			return FSD_DRMAA_ERRNO_INVALID_CONTACT_STRING;
+		case DRMAA_ERRNO_DEFAULT_CONTACT_STRING_ERROR:
+			return FSD_DRMAA_ERRNO_DEFAULT_CONTACT_STRING_ERROR;
+		case DRMAA_ERRNO_NO_DEFAULT_CONTACT_STRING_SELECTED:
+			return FSD_DRMAA_ERRNO_NO_DEFAULT_CONTACT_STRING_SELECTED;
+		case DRMAA_ERRNO_DRMS_INIT_FAILED:
+			return FSD_ERRNO_DRMS_INIT_FAILED;
+		case DRMAA_ERRNO_ALREADY_ACTIVE_SESSION:
+			return FSD_DRMAA_ERRNO_ALREADY_ACTIVE_SESSION;
+		case DRMAA_ERRNO_DRMS_EXIT_ERROR:
+			return FSD_ERRNO_DRMS_EXIT_ERROR;
+		case DRMAA_ERRNO_INVALID_ATTRIBUTE_FORMAT:
+			return FSD_DRMAA_ERRNO_INVALID_ATTRIBUTE_FORMAT;
+		case DRMAA_ERRNO_INVALID_ATTRIBUTE_VALUE:
+			return FSD_DRMAA_ERRNO_INVALID_ATTRIBUTE_VALUE;
+		case DRMAA_ERRNO_CONFLICTING_ATTRIBUTE_VALUES:
+			return FSD_DRMAA_ERRNO_CONFLICTING_ATTRIBUTE_VALUES;
+		case DRMAA_ERRNO_TRY_LATER:
+			return FSD_ERRNO_TRY_LATER;
+		case DRMAA_ERRNO_DENIED_BY_DRM:
+			return FSD_ERRNO_DENIED_BY_DRM;
+		case DRMAA_ERRNO_INVALID_JOB:
+			return FSD_DRMAA_ERRNO_INVALID_JOB;
+		case DRMAA_ERRNO_RESUME_INCONSISTENT_STATE:
+			return FSD_DRMAA_ERRNO_RESUME_INCONSISTENT_STATE;
+		case DRMAA_ERRNO_SUSPEND_INCONSISTENT_STATE:
+			return FSD_DRMAA_ERRNO_SUSPEND_INCONSISTENT_STATE;
+		case DRMAA_ERRNO_HOLD_INCONSISTENT_STATE:
+			return FSD_DRMAA_ERRNO_HOLD_INCONSISTENT_STATE;
+		case DRMAA_ERRNO_RELEASE_INCONSISTENT_STATE:
+			return FSD_DRMAA_ERRNO_RELEASE_INCONSISTENT_STATE;
+		case DRMAA_ERRNO_EXIT_TIMEOUT:
+			return FSD_DRMAA_ERRNO_EXIT_TIMEOUT;
+		case DRMAA_ERRNO_NO_RUSAGE:
+			return FSD_DRMAA_ERRNO_NO_RUSAGE;
+		case DRMAA_ERRNO_NO_MORE_ELEMENTS:
+			return FSD_ERRNO_STOP_ITERATION;
+		default:
+			fsd_assert(false);
+			return FSD_ERRNO_INTERNAL_ERROR;
+	 }
+}
+
+
+const char *
+fsd_drmaa_strerror( int drmaa_errno )
+{
+	switch( drmaa_errno )
+	 {
+		case DRMAA_ERRNO_SUCCESS:
+			return "Success.";
+		case DRMAA_ERRNO_INTERNAL_ERROR:
+			return "Unexpected or internal DRMAA error.";
+		case DRMAA_ERRNO_DRM_COMMUNICATION_FAILURE:
+			return "Could not contact DRM system for this request.";
+		case DRMAA_ERRNO_AUTH_FAILURE:
+			return "Authorization failure.";
+		case DRMAA_ERRNO_INVALID_ARGUMENT:
+			return "Invalid argument value.";
+		case DRMAA_ERRNO_NO_ACTIVE_SESSION:
+			return "No active DRMAA session.";
+		case DRMAA_ERRNO_NO_MEMORY:
+			return "Not enough memory.";
+		case DRMAA_ERRNO_INVALID_CONTACT_STRING:
+			return "Invalid contact string.";
+		case DRMAA_ERRNO_DEFAULT_CONTACT_STRING_ERROR:
+			return "Can not determine default contact to DRM system.";
+		case DRMAA_ERRNO_NO_DEFAULT_CONTACT_STRING_SELECTED:
+			return "Contact to DRM must be set explicitly "
+				"because there is no default.";
+		case DRMAA_ERRNO_DRMS_INIT_FAILED:
+			return "Unable to initialize DRM system.";
+		case DRMAA_ERRNO_ALREADY_ACTIVE_SESSION:
+			return "DRMAA session already exist.";
+		case DRMAA_ERRNO_DRMS_EXIT_ERROR:
+			return "Disengagement from the DRM system failed.";
+		case DRMAA_ERRNO_INVALID_ATTRIBUTE_FORMAT:
+			return "Invalid format of job attribute.";
+		case DRMAA_ERRNO_INVALID_ATTRIBUTE_VALUE:
+			return "Invalid value of job attribute.";
+		case DRMAA_ERRNO_CONFLICTING_ATTRIBUTE_VALUES:
+			return "Value of attribute conflicts with other attribute value.";
+		case DRMAA_ERRNO_TRY_LATER:
+			return "DRM system is overloaded.  Try again later.";
+		case DRMAA_ERRNO_DENIED_BY_DRM:
+			return "DRM rejected job due to its configuration or job attributes.";
+		case DRMAA_ERRNO_INVALID_JOB:
+			return "Job does not exist in DRMs queue.";
+		case DRMAA_ERRNO_RESUME_INCONSISTENT_STATE:
+			return "Can not resume job (not in valid state).";
+		case DRMAA_ERRNO_SUSPEND_INCONSISTENT_STATE:
+			return "Can not suspend job (not in valid state).";
+		case DRMAA_ERRNO_HOLD_INCONSISTENT_STATE:
+			return "Can not hold job (not in valid state).";
+		case DRMAA_ERRNO_RELEASE_INCONSISTENT_STATE:
+			return "Can not release job (not in valid state).";
+		case DRMAA_ERRNO_EXIT_TIMEOUT:
+			return "Waiting for job to terminate finished due to time-out.";
+		case DRMAA_ERRNO_NO_RUSAGE:
+			return "Job finished but resource usage information "
+				"and/or termination status could not be provided.";
+		case DRMAA_ERRNO_NO_MORE_ELEMENTS:
+			return "Vector have no more elements.";
+
+		default:
+			return "Unknown DRMAA error code!?";
+	 }
+}
+
Index: trunk/drmaa_utils/drmaa_utils/datetime_impl.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/datetime_impl.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/datetime_impl.h	(revision 1)
@@ -0,0 +1,73 @@
+/* $Id: datetime_impl.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file datetime_impl.h
+ * DRMAA date/time parser - Bison interface functions.
+ */
+#ifndef __DRMAA_UTILS__DATETIME_IMPL_H
+#define __DRMAA_UTILS__DATETIME_IMPL_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/datetime.h>
+
+/** @addtogroup datetime */
+/* @{ */
+
+typedef struct fsd_dt_parser_s fsd_dt_parser_t;
+typedef struct fsd_dt_lexer_s fsd_dt_lexer_t;
+union YYSTYPE;
+
+/** Date/time parser data. */
+struct fsd_dt_parser_s {
+	fsd_dt_lexer_t *lexer;  /**< Lexical analyzer. */
+	fsd_datetime_t result;  /**< Parsing result. */
+	int n_errors; /**< Number of parse errors. */
+};
+
+/** Date/time lexical analyzer. */
+struct fsd_dt_lexer_s {
+	fsd_dt_parser_t *parser;  /**< Date/time parser. */
+	const unsigned char *begin; /**< Begin of parsed string. */
+	const unsigned char *end;   /**< End of parsed string. */
+	const unsigned char *p;     /**< Scanner position
+		(points to first not parsed character). */
+};
+
+/** Parser interface function (Bison generated). */
+int fsd_dt_parse( fsd_dt_parser_t *parser, fsd_dt_lexer_t *lexer );
+
+/**
+ * Error reporting function (hand written).
+ */
+void fsd_dt_error(
+		fsd_dt_parser_t *parser, fsd_dt_lexer_t *lexer,
+		const char *fmt, ...
+		);
+
+/** Lexer interface (hand written). */
+int fsd_dt_lex( union YYSTYPE *lvalp, fsd_dt_lexer_t *lexer );
+
+/* @} */
+
+#endif /* __DRMAA_UTILS__DATETIME_IMPL_H */
+
Index: trunk/drmaa_utils/drmaa_utils/compat.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/compat.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/compat.c	(revision 1)
@@ -0,0 +1,162 @@
+/* $Id: compat.c 138 2010-04-29 17:13:31Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <errno.h>
+#include <string.h>
+#include <assert.h>
+#include <drmaa_utils/compat.h>
+
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: compat.c 138 2010-04-29 17:13:31Z mamonski $";
+#endif
+
+
+#ifndef HAVE_STRLCPY
+size_t
+strlcpy( char *dest, const char *src, size_t size )
+{
+	size_t result = 0;
+	if( size == 0 )
+		return 0;
+	while( *src  &&  --size > 0 )
+	 {
+		*dest++ = *src++;
+		result++;
+	 }
+	*dest++ = '\0';
+	return result;
+}
+#endif /* ! HAVE_STRLCPY */
+
+
+#ifndef HAVE_STRNDUP
+char *
+strndup( const char *s, size_t n )
+{
+	char *result;
+	if( s == NULL )
+		return NULL;
+	result = calloc( n + 1, sizeof(char) );
+
+	if( result == NULL )
+	 {
+		errno = ENOMEM;
+		return NULL;
+	 }
+
+	strlcpy( result, s, n + 1 );
+	return result;
+}
+#endif /* ! HAVE_STRNDUP */
+
+
+#ifndef HAVE_ASPRINTF
+int
+asprintf( char **strp, const char *fmt, ... )
+{
+	va_list args;
+	int result;
+	va_start( args, fmt );
+	result = vasprintf( strp, fmt, args );
+	va_end( args );
+	return result;
+}
+#endif /* ! HAVE_ASPRINTF */
+
+
+#ifndef HAVE_VASPRINTF
+int
+vasprintf( char **strp, const char *format, va_list ap )
+{
+	int size, check_size;
+	char *buf = NULL;
+
+#ifdef HAVE_VA_COPY
+	va_list aq;
+
+	va_copy(aq, ap);
+#else
+#  ifdef HAVE___VA_COPY
+	va_list aq;
+
+	__va_copy(aq, ap);
+#  endif
+#endif
+
+	*strp = NULL;
+
+#ifndef HAVE_C99_VSNPRINTF
+	{
+		int res;
+		char *tmp;
+
+		size = 128;
+		do {
+			size *= 2;
+			if (!(tmp = realloc(buf, size))) {
+				if (buf)
+					free(buf);
+				return -1;
+			}
+			buf = tmp;
+			/* XXX we're assuming here there's no va_copy on this system */
+			res = vsnprintf(buf, size, format, ap);
+		} while (res == -1);
+	}
+#else
+	{
+		char tmp[2];
+
+		/* on Solaris vsnprintf fails if buf is empty, so use a small one */
+		size = vsnprintf(tmp, sizeof(tmp), format, ap);
+		if (!(buf = malloc(size + 1)))
+			return -1;
+	}
+#endif
+
+#ifdef HAVE_VA_COPY
+	check_size = vsnprintf(buf, size + 1, format, aq);
+	va_end(aq);
+#else
+#  ifdef HAVE___VA_COPY
+	check_size = vsnprintf(buf, size + 1, format, aq);
+	va_end(aq);
+#  else
+	check_size = vsnprintf(buf, size + 1, format, ap);
+#  endif
+#endif
+	assert(check_size <= size);
+	*strp = buf;
+	return 0;
+}
+#endif
+
Index: trunk/drmaa_utils/drmaa_utils/drmaa_base.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/drmaa_base.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/drmaa_base.h	(revision 1)
@@ -0,0 +1,76 @@
+/* $Id: drmaa_base.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ * FedStage DRMAA utilities library
+ * Copyright (C) 2006-2008  FedStage Systems
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__DRMAA_BASE_H
+#define __DRMAA_UTILS__DRMAA_BASE_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/thread.h>
+
+struct fsd_drmaa_singletone_s {
+	/** Global session object */
+	fsd_drmaa_session_t *session;
+	fsd_mutex_t session_mutex;
+
+	fsd_drmaa_session_t *(*new_session)(
+			fsd_drmaa_singletone_t *self,
+			const char *contact
+			);
+
+	fsd_template_t *(*new_job_template)(
+			fsd_drmaa_singletone_t *self
+			);
+
+	const char* (*get_contact)( fsd_drmaa_singletone_t *self );
+	void (*get_version)(
+			fsd_drmaa_singletone_t *self,
+			unsigned *major, unsigned *minor
+			);
+	const char* (*get_DRM_system)( fsd_drmaa_singletone_t *self );
+	const char* (*get_DRMAA_implementation)( fsd_drmaa_singletone_t *self );
+
+	fsd_iter_t * (*
+	get_attribute_names)(
+		fsd_drmaa_singletone_t *self );
+
+	fsd_iter_t * (*
+	get_vector_attribute_names)(
+		fsd_drmaa_singletone_t *self );
+
+	int (*wifexited)( int *exited, int stat,
+		char *error_diagnosis, size_t error_diag_len );
+	int (*wexitstatus)( int *exit_status, int stat,
+		char *error_diagnosis, size_t error_diag_len );
+	int (*wifsignaled)( int *signaled, int stat,
+		char *error_diagnosis, size_t error_diag_len );
+	int (*wtermsig)( char *signal, size_t signal_len, int stat,
+		char *error_diagnosis, size_t error_diag_len );
+	int (*wcoredump)( int *core_dumped, int stat,
+		char *error_diagnosis, size_t error_diag_len );
+	int (*wifaborted)( int *aborted, int stat,
+		char *error_diagnosis, size_t error_diag_len );
+};
+
+extern fsd_drmaa_singletone_t _fsd_drmaa_singletone;
+
+#endif /* __DRMAA_UTILS__DRMAA_BASE_H */
Index: trunk/drmaa_utils/drmaa_utils/environ.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/environ.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/environ.h	(revision 1)
@@ -0,0 +1,81 @@
+/* $Id: environ.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ * FedStage DRMAA utilities library
+ * Copyright (C) 2006-2008  FedStage Systems
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__ENVIRON_H
+#define __DRMAA_UTILS__ENVIRON_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/compat.h>
+
+typedef struct fsd_environ_s fsd_environ_t;
+typedef struct fsd_environ_item_s fsd_environ_item_t;
+
+struct fsd_environ_s {
+	void (*
+	destroy)( fsd_environ_t *self );
+
+	const char* (*
+	get)( fsd_environ_t *self, const char *name );
+
+	void (*
+	set)( fsd_environ_t *self, char *name, char *value );
+
+	void (*
+	update)( fsd_environ_t *self, const char *const envp[] );
+
+	char ** (*
+	list)( fsd_environ_t *self );
+
+	/**
+	 * Modifies process's environment overwriting variables
+	 * set in environ object.
+	 * @return  Dictionary of overwritten values.
+	 * @see #restore
+	 */
+	fsd_environ_t * (*
+	apply)( fsd_environ_t *self );
+
+	/**
+	 * Restore process's environment to original state.
+	 * All variables from \a self gets overwritten with values
+	 * from \a saved_state or unset if variable doesn't exist
+	 * in \a saved_state.
+	 * @see #apply
+	 */
+	void (*
+	restore)( fsd_environ_t *self, fsd_environ_t *saved_state );
+
+	fsd_environ_item_t **_table;
+	unsigned _table_size;
+};
+
+fsd_environ_t *
+fsd_environ_new( const char *const envp[] );
+
+struct fsd_environ_item_s {
+	fsd_environ_item_t *next;
+	char *name;
+	char *value;
+};
+
+#endif /* __DRMAA_UTILS__ENVIRON_H */
+
Index: trunk/drmaa_utils/drmaa_utils/drmaa_util.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/drmaa_util.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/drmaa_util.h	(revision 1)
@@ -0,0 +1,91 @@
+/* $Id: drmaa_util.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__DRMAA_UTIL_H
+#define __DRMAA_UTILS__DRMAA_UTIL_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/common.h>
+
+enum{
+	FSD_DRMAA_PH_HD    = 1<<0,
+	FSD_DRMAA_PH_WD    = 1<<1,
+	FSD_DRMAA_PH_INCR  = 1<<2
+};
+
+struct fsd_expand_drmaa_ph_s {
+	/**
+	 * Expands placeholders in DRMAA job attribute value.
+	 * @param self   Context.
+	 * @param input  String to transform.  Should be malloc'ed
+	 *   and ownership is passed to callee.
+	 * @param set    Set of placeholders to expand.  Bitwise
+	 *   `or' of any of following bits:
+	 *   - FSD_DRMAA_PH_HD,
+	 *   - FSD_DRMAA_PH_WD,
+	 *   - FSD_DRMAA_PH_INCR
+	 * @return Value with expanded placeholders or \c NULL
+	 *   upon error.  Caller is responsible for free()'ing it.
+	 */
+	char *(*
+	expand)( fsd_expand_drmaa_ph_t *self, char *input, unsigned set );
+
+	void (*
+	set)( fsd_expand_drmaa_ph_t *self, int placeholder, char *value );
+
+	void (*destroy)( fsd_expand_drmaa_ph_t *self );
+
+	char *home_directory;
+	char *working_directory;
+	char *bulk_incr;
+};
+
+fsd_expand_drmaa_ph_t *
+fsd_expand_drmaa_ph_new(
+		char *home_directory,
+		char *working_directory,
+		char *bulk_incr
+		);
+
+int fsd_parse_timedelta( const char *string );
+
+/**
+ * Return textual representation of action
+ * - argument of drmaa_control().
+ */
+const char *drmaa_control_to_str( int action );
+
+/**
+ * Return textual representation of job status
+ * - result of drmaa_job_ps().
+ */
+const char *drmaa_job_ps_to_str( int ps );
+
+int fsd_drmaa_code( int fsd_errno );
+
+int fsd_errno_from_drmaa_code( int drmaa_errno );
+
+const char *
+fsd_drmaa_strerror( int drmaa_errno );
+
+#endif /* __DRMAA_UTILS__DRMAA_UTIL_H */
+
Index: trunk/drmaa_utils/drmaa_utils/compat.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/compat.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/compat.h	(revision 1)
@@ -0,0 +1,77 @@
+/* $Id: compat.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__COMPAT_H
+#define __DRMAA_UTILS__COMPAT_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <sys/types.h>
+
+#include <stddef.h>
+#include <stdarg.h>
+
+#ifdef HAVE_STDINT_H
+#	include <stdint.h>
+#else
+#	ifdef HAVE_INTTYPES_H
+#		include <inttypes.h>
+#	else
+#		warning "no stdint.h nor inttypes.h found"
+#	endif
+#endif /* ! HAVE_STDINT_H */
+
+#ifdef HAVE_STDBOOL_H
+#	include <stdbool.h>
+#else
+#	ifndef bool
+#		define bool int
+#	endif
+#	ifndef true
+#		define true 1
+#	endif
+#	ifndef false
+#		define false 0
+#	endif
+#endif /* ! HAVE_STDBOOL_H */
+
+#ifndef HAVE_STRLCPY
+size_t strlcpy( char *dest, const char *src, size_t size )
+	__attribute__(( weak ));
+#endif
+
+#ifndef HAVE_STRNDUP
+char *strndup( const char *s, size_t n )
+	__attribute__(( weak ));
+#endif
+
+#ifndef HAVE_ASPRINTF
+int asprintf( char **strp, const char *fmt, ... )
+	__attribute__(( weak ));
+#endif
+
+#ifndef HAVE_VASPRINTF
+int vasprintf( char **strp, const char *fmt, va_list ap )
+	__attribute__(( weak ));
+#endif
+
+#endif /* __DRMAA_UTILS__COMPAT_H */
+
